#include "HelixPso.h"
#include <ctime>
#define  DINFTY       1.e32    
#define  ZERO         1.e-10
//#include "/homes/bierdepot/michael/C/ViennaRNA-1.7/Cluster/split.h"

//SWITCH ON IF STATISTICS ARE DESIRED
//#DEFINE DO_STATS

using namespace std;


// int bp_distance(const char *str1, const char *str2)
// {
//   /* dist = {number of base pairs in one structure but not in the other} */
//   /* same as edit distance with pair_open pair_close as move set */
//    int dist;
//    short i,l;
//    short *t1, *t2;

//    dist = 0;
//    t1 = make_pair_table(str1);
//    t2 = make_pair_table(str2);
   
//    l = (t1[0]<t2[0])?t1[0]:t2[0];    /* minimum of the two lengths */
   
//    for (i=1; i<=l; i++)
//      if (t1[i]!=t2[i]) {
//        if (t1[i]>i) dist++;
//        if (t2[i]>i) dist++;
//      }
//    free(t1); free(t2);
//    return dist;
// }

typedef struct {
        int   *splitlist[2];
        int    splitsize;
        double   isolation_index; } Split;

Split *split_decomposition(float **dist)
{

   int      elm, n_of_splits;
   short   *full_slots;
   int      i,j,sp,new_sp,spp;
   int      i2,j1,j2,maxlen;
   int      x,y,z;
   double   alpha,beta,tmp;
   double   test1,test2;
   Split   *SD, *S;
   int number_of_points;
   
   number_of_points = (int) dist[0][0];
   
   /* Initialize */ 
   elm = 2;
   n_of_splits = 1;
   maxlen = (number_of_points+1)*(number_of_points+1);
   full_slots = (short *) space(2*(maxlen+1)*sizeof(int));
   full_slots[1]=1;
   
   SD = (Split   *)space((maxlen+1)*sizeof(Split));
   
   SD[0].splitlist[0]    = NULL;
   SD[0].splitlist[1]    = NULL; 
   SD[0].splitsize       = 1;
   SD[0].isolation_index = 0.0;
   /**/ 
   SD[1].splitlist[0]    = (int *) space((number_of_points+1)*sizeof(int));
   SD[1].splitlist[0][0] = number_of_points;
   SD[1].splitlist[0][1] = 1;
   SD[1].splitlist[1]    = (int *) space((number_of_points+1)*sizeof(int));
   SD[1].splitlist[1][1] = 2;
   SD[1].splitsize       = 1;
   SD[1].isolation_index = dist[1][2];


   /* Iteration */

   for( elm=3; elm <= number_of_points; elm++){

      for (sp=1, spp=n_of_splits;sp<=n_of_splits; sp++){
           
	 SD[sp].splitlist[0][0] = elm;

	 /* 1.  Split = {old_A | old_B+{elm}}  */

	 alpha = 2.0*SD[sp].isolation_index;
	 for(i2=1; i2<=(elm - SD[sp].splitsize); i2++){
	    if(i2==(elm-SD[sp].splitsize)) {
	       x = elm;
	    }
	    else{
	       x= SD[sp].splitlist[1][i2];
	    }
	    for(j1=1; j1 <= SD[sp].splitsize; j1++){
	       y= SD[sp].splitlist[0][j1];
	       for(j2=1; j2 <= (SD[sp].splitsize); j2++){
		  z= SD[sp].splitlist[0][j2];

		  /* calculate the value beta = beta(elm,x; y,z) */ 

		  beta = dist[elm][y] + dist[x][z];
		  tmp  = dist[elm][z] + dist[x][y];
		  if(tmp>beta) beta=tmp;
		  tmp  = dist[elm][x] + dist[y][z];
		  if(tmp>beta) beta=tmp;
		  beta -= ( dist[elm][x] + dist[y][z] );

		  if(beta<alpha) alpha=beta;
	       }
	    }
	 }
	 alpha/=2.;
           
	 if (alpha > ZERO){
	    /* add {old_A | old_B + {elm}} to the split-list */
	    spp++;
	    full_slots[spp] =1;
	    SD[spp].splitsize       = SD[sp].splitsize;
	    SD[spp].isolation_index = alpha;
	    SD[spp].splitlist[0]    = (int *) space((number_of_points+1)*sizeof(int));
	    SD[spp].splitlist[0][0] = elm;
	    SD[spp].splitlist[1]    = (int *) space((number_of_points+1)*sizeof(int));
	    for(i=1; i<=SD[spp].splitsize; i++)
	       SD[spp].splitlist[0][i] = SD[sp].splitlist[0][i];
	    for(i=1; i<=(elm-1-SD[spp].splitsize); i++)
	       SD[spp].splitlist[1][i] = SD[sp].splitlist[1][i];
	    SD[spp].splitlist[1][elm-SD[spp].splitsize] = elm;
	 }
    
	 /* 2. Split = {old_A+{elm} | old_B}   */

	 alpha = 2.0*SD[sp].isolation_index;
	 for(i2=1; i2<= (SD[sp].splitsize+1); i2++){
	    if(i2==(SD[sp].splitsize+1)){
	       x= elm;
	    }
	    else
	       {
		  x= SD[sp].splitlist[0][i2];
	       }
	    for(j1=1; j1 <= (elm-1-SD[sp].splitsize); j1++){
	       y= SD[sp].splitlist[1][j1];
	       for(j2=1; j2 <= (elm-1-SD[sp].splitsize); j2++){
		  z= SD[sp].splitlist[1][j2];

		  /* calculate the value beta = beta(elm,x; y,z) */ 

		  beta = dist[elm][y] + dist[x][z];
		  tmp  = dist[elm][z] + dist[x][y];
		  if(tmp>beta) beta=tmp;
		  tmp  = dist[elm][x] + dist[y][z];
		  if(tmp>beta) beta=tmp;
		  beta -= ( dist[elm][x] + dist[y][z] );

		  if(beta<alpha) alpha=beta;
	       }
	    }
	 }
	 alpha/=2.;

	 if (alpha > ZERO){
	    /* replace {old_A | old_B} by {old_A+{elm} | old_B} in the splitlist */
	    SD[sp].splitsize++;
	    SD[sp].splitlist[0][SD[sp].splitsize] = elm;
	    SD[sp].isolation_index = alpha;
	 }
	 else{
	    /* remove {old_A | old_B} from the split list */
	    full_slots[sp] = 0;
	    free(SD[sp].splitlist[0]);
	    SD[sp].splitlist[0]    = NULL;
	    free(SD[sp].splitlist[1]);
	    SD[sp].splitlist[1]    = NULL;
	    SD[sp].splitsize       = 0;
	    SD[sp].isolation_index = 0.0;
	 }
      }

      /* 3.  Split =  { {elm} | {1,...,elm-1} } */

      alpha=DINFTY;
      for(i=1;i<=elm-1;i++){
	 for(j=1; j<=elm-1;j++){
	    tmp = dist[elm][i]+dist[elm][j] - dist[i][j];
	    if( tmp < alpha) alpha = tmp;   
	 }
      }
      alpha/=2.;
      if (alpha > ZERO){
	 spp++;
	 full_slots[spp] = 1;
	 SD[spp].splitsize         = 1;
	 SD[spp].isolation_index   = alpha;
	 SD[spp].splitlist[0]      = (int *) space((number_of_points+1)*sizeof(int));
	 SD[spp].splitlist[0][0]   = elm;
	 SD[spp].splitlist[1]      = (int *) space((number_of_points+1)*sizeof(int));
	 SD[spp].splitlist[0][1]   = elm;
	 for (i=1; i<= elm-1; i++)
	    SD[spp].splitlist[1][i] = i;
      }
      /* note that spp now points to the last entry in the splitlist !!! */

      /* garbage collection .... unfortunately a bit boring */

      for ( sp=1, new_sp=0; sp<= spp; sp++ ){
	 if (full_slots[sp]){
	    new_sp++;
	    if(sp != new_sp){
	       /* copy all the junk from sp to new_sp */
	       full_slots[new_sp]=1; full_slots[sp]=0;
	       SD[new_sp].splitsize        = SD[sp].splitsize;
	       SD[new_sp].isolation_index  = SD[sp].isolation_index;
	       if(SD[new_sp].splitlist[0]==NULL) 
		  SD[new_sp].splitlist[0] = (int *) space((number_of_points+1)*sizeof(int));
	       if(SD[new_sp].splitlist[1]==NULL) 
		  SD[new_sp].splitlist[1] = (int *) space((number_of_points+1)*sizeof(int));
	       for(i=0;i<=elm;i++){
		  SD[new_sp].splitlist[0][i]  = SD[sp].splitlist[0][i];
		  SD[new_sp].splitlist[1][i]  = SD[sp].splitlist[1][i];
	       }
	       free(SD[sp].splitlist[0]);
	       SD[sp].splitlist[0] = NULL;
	       free(SD[sp].splitlist[1]);
	       SD[sp].splitlist[1] = NULL;
	       SD[sp].splitsize       = 0;
	       SD[sp].isolation_index = 0.0;
	    }
	 }
      }
      n_of_splits = new_sp;
      SD[0].splitsize = n_of_splits;
   } /* End of iteration */


   /* Calculate fraction of split-prime part for the full matrix
      if not already done */

   for(test1=0.0, i=2; i<=number_of_points; i++) 
      for( j=1; j<i; j++) test1+=dist[i][j];
   for(test2=0.0, i=1; i<= n_of_splits; i++) 
      test2 += (number_of_points-SD[i].splitsize)*
	 SD[i].splitsize*SD[i].isolation_index;
   SD[0].isolation_index = (test1 - test2)/test1;
   
   /* free superfluous space */ 

   S = (Split *)space((n_of_splits+1)*sizeof(Split));
   for (i=0; i<= n_of_splits; i++) S[i] = SD[i];
   free(SD);
   return(S);
}  


int CompareSplit(const void *v1 , const void *v2)
{
   Split *S1, *S2;

   S1 = (Split *) v1; S2 = (Split *) v2;
   if(S1->isolation_index < S2->isolation_index) return +1;
   if(S2->isolation_index < S1->isolation_index) return -1;
   return 0;
}

void sort_Split(Split *x) 
{
   int i,j;
   int t1;

   qsort((void *) &(x[1]), x[0].splitsize ,sizeof(Split),CompareSplit );
  
   for(i=1; i<=x[0].splitsize; i++) {
      if(x[i].splitsize > x[i].splitlist[0][0]-x[i].splitsize) {
         for(j=1; j<=x[i].splitsize; j++) {
            t1 = x[i].splitlist[0][j];
            x[i].splitlist[0][j] = x[i].splitlist[1][j];
            x[i].splitlist[1][j] = t1;
         }
         x[i].splitsize = x[i].splitlist[0][0]-x[i].splitsize;
      }
   }
}

double Score(std::pair<double,std::string> struc,double centroid,double mfe){
  double mfe_component=(1-centroid)*max(0,struc.first/mfe);
    double centroid_component=centroid*(double)HelixPso::CentroidMatchBpCount(struc.second).first/(double)HelixPso::bp_centroid.size();
    double score=mfe_component+centroid_component;
    return score;

}
int main (int argc, char *argv[]) {


  //  std::string s1="......((.......))..((((....)))).......(((((..((((...........(((((.......))))).((((((((...))))))))..)))).((......)).)))))";
  //std::string s2=".(((((((((........(((((................))))).((((...................(((...))).((((((((...))))))))..))))......)))))))))..";
  //int distance= HelixPso::Distance(s1,s2);
  //cout<<"distance "<<distance<<std::endl;
  //exit(0);

  bool verbose=false;//true;
  bool do_stats=false;//rue;

  std::pair<int,int> best_pred_of_global_bests=std::pair<int,int>(0,0);
  std::vector<double> TP=  std::vector<double>();
 
  
  clock_t start,finish;
  double runningtime;
  start = clock();

  string sLog=string();
  int algo_seed=(int) time(NULL);//(int) time;

  // Process commandline options
  OptionS *OptS;
  OptS = decodeCML(argc, argv);
  std::string path=std::string(OptS->infile);

  std::string algo=std::string(OptS->algo);
  //RNA
  std::string RNA;
  std::string native_structure;
 //  std::string path1="rna/"+path;
//   std::string path2="rna/prev/"+path;
//   cout<<"path1 "<<path1<<std::endl;
//   cout<<"path2 "<<path2<<std::endl;
//   ifstream infile(path1.c_str());
 ifstream infile(path.c_str());

 



  // ifstream infile2(path2.c_str());
//   std::string old_centroid_structure;
//   getline(infile2,old_centroid_structure);
//   getline(infile2,old_centroid_structure);
//   getline(infile2,old_centroid_structure);

  getline(infile,RNA);
  int length=RNA.size();
  getline(infile,native_structure); 
  //USED IN HELIXPSO FOR THE STATISTICS
  if(do_stats) HelixPso::bp_native=RNAParameters::MakeBasePairList(native_structure);







  //ifstream infilebarrier(("barrier"+Str(length)).c_str()  );

/**
  //QUARANTAENE
  std::string centroid_structure2;
  getline(infile,centroid_structure2); 
  std::vector<std::pair<int,int> >  bp_centroid=RNAParameters::MakeBasePairList(centroid_structure2);
  std::vector<std::pair<int,int> >  bp_native=RNAParameters::MakeBasePairList(native_structure);

  int bpcorrect=0;
  for(std::vector<std::pair<int,int> >::iterator it=bp_centroid2.begin();it!=bp_centroid2.end();it++){
        if(find(bp_native.begin(),bp_native.end(),*it)!= bp_native.end()) bpcorrect++;
      }
   cout<<"bp matching "<<bpcorrect<<std::endl;
  exit(0);
//  */

  //if(do_stats) getline(infile,native_structure); 
  //else         ;//getline(infile,centroid_structure); 
  //getline(infile,centroid_structure); 
  //if there are only two lines, set the native structure to the centroid structure.
  //IN THIS CASE, THE STATISTICS OF TP,FP,FN OF COURSE CANNOT BE USED, AS THE NATIVE STRUCTURE IS NOT KNOWN.
  //if(centroid_structure.size()==0) centroid_structure=native_structure;


  RNAParameters::InitializeViennaRNA(RNA);
  char *sequence  = new char[length+1];
  char *structure = new char[length+1];
  strcpy(sequence, RNA.c_str());
  double mfe = fold(sequence, structure);
  std::string mfe_structure=std::string(structure);


  init_pf_fold(length);
  strcpy(sequence, RNA.c_str());
  //float pf_fold_ret=
  pf_fold(sequence,structure);
  // clean up memory
  delete[] sequence;
  delete[] structure;
  char *Ccentroid_structure;
  double dist;
  Ccentroid_structure = centroid(length, &dist);
  std::string centroid_structure=std::string(Ccentroid_structure);  
  // getline(infile,centroid_structure); 


   int n_divisions=1;
  RNAParameters p=RNAParameters(RNA,native_structure,OptS->loopsize,OptS->initial_stacksize,OptS->final_stacksize,OptS->reference,n_divisions);
HelixPso::bp_centroid=RNAParameters::MakeBasePairList(centroid_structure);

 HelixPso::alpha=OptS->alpha;


  /**
  //QUARANTAENE
 std::string barrier_structure=std::string();//
 while(getline(infilebarrier,barrier_structure)){
   barrier_structure=barrier_structure.substr(5,length);
  std::string centroid_structure2;
  //  getline(infile,centroid_structure2); 
  //std::vector<std::pair<int,int> >  bp_centroid2=RNAParameters::MakeBasePairList(centroid_structure2);
  // std::vector<std::pair<int,int> >  bp_centroid=RNAParameters::MakeBasePairList(centroid_structure);
  std::vector<std::pair<int,int> >  bp_barrier=RNAParameters::MakeBasePairList(barrier_structure);
  std::vector<std::pair<int,int> >  bp_native=RNAParameters::MakeBasePairList(native_structure);

  int bpcorrect=0;
  for(std::vector<std::pair<int,int> >::iterator it=bp_barrier.begin();it!=bp_barrier.end();it++){
        if(find(bp_native.begin(),bp_native.end(),*it)!= bp_native.end()) bpcorrect++;
      }

 //for(std::vector<std::pair<int,int> >::iterator it=bp_centroid2.begin();it!=bp_centroid2.end();it++){
 //     if(find(bp_centroid.begin(),bp_centroid.end(),*it)!= bp_centroid.end()) bpcorrect++;
 //    }
   cout<<"_"+barrier_structure+"_ bp matching "<<bpcorrect<<std::endl;
   //cout<<"bp not matching "<<(bpcorrect-(int)bp_centroid.size())<<std::endl;

  }
  exit(0);
//  */


  //centroid_structure=mfe_structure;
  std::cout<<"RNA      "+RNA<<std::endl;
  std::cout<<"mfE      "+mfe_structure+":"+Str(mfe)<<std::endl;
  std::cout<<"Centroid "+centroid_structure<<std::endl;

  //  exit(1);










 



  //std::string mfe_structure;
  //getline(infile,mfe_structure); 
 


  std::string search_method=string(OptS->search_method);
  
  double min_prob_S=.05;
  SearchParameters sp=SearchParameters(OptS->particles,OptS->iterations,OptS->total_solutions,OptS->solutions_report_interval,OptS->reference,OptS->steps,OptS->evaporate,OptS->add,OptS->random,OptS->pstack,OptS->pbest,OptS->gbest,min_prob_S,search_method);
  int runs=OptS->runs;
 
  srand48(algo_seed);
  sLog+=algo+" seed:"+Str(algo_seed)+"\n";
  sLog+="Run "+algo+" "+Str(runs)+" times on a sequence of length "+Str((int)RNA.size())+"\n";
  
  int n_solutions_to_print=1+OptS->total_solutions/OptS->solutions_report_interval;
  std::vector<double> mean_best=std::vector<double>(n_solutions_to_print);
  std::vector<double> best_by_run=std::vector<double>();
  //int total_solutions=OptS->total_solutions;
  HelixPso::evaporation_threshold=OptS->evaporation_threshold;
  HelixPso::swap_select=OptS->swap_select;

//   sLog+"particles  "+Str(OptS->particles)+"\n";
//   sLog+"iterations "+Str(OptS->iterations)+"\n";
//   sLog+"runs       "+Str(OptS->runs)+"\n";
//   sLog+"inertia    "+Str(OptS->evaporate)+"\n";
//   sLog+"clusters   "+Str(OptS->clusters)+"\n";
//   sLog+"swap_select"+Str(OptS->swap_select)+"\n";
//   sLog+"pbest      "+Str(OptS->pbest)+"\n";
//   sLog+"gbest      "+Str(OptS->gbest)+"\n";


//sLog+"  "+Str(   )+"\n";

  HelixPso::CreateStemList(p); 	
   sLog+"stemlist size "+Str((int)HelixPso::stemlist.size())+"\n"; 
  HelixPso::transposition_count_sections=OptS->transposition_count_sections;
  HelixPso::InitializeTranspositionCounters(); 
  HelixPso::accepted_solution_count_sections=OptS->accepted_solution_count_sections;
  HelixPso::InitializeAcceptedSolutionCounter(); 
  HelixPso::sv_stat_sections=OptS->sv_stat_sections; 

 

  HelixPso::PrepareSVStatistics(); 
  HelixPso::rule=OptS->rule;
  HelixPso::centroid_weight=OptS->centroid;

  //  std::string outdir=std::string();
  //outdir="testHelixPso/cen"+Str((int)(100*OptS->centroid))+"/";
  //std::string filename=outdir+algo+"_it"+Str(OptS->iterations)+"_centroid"+Str((int)(100*OptS->centroid))+"_runs"+Str(runs)+"_"+Str((int)RNA.size())+".txt";

  std::string filename=algo+"_p"+Str(OptS->particles)+"_it"+Str(OptS->iterations)+"_centroid"+Str((int)(100*OptS->centroid))+"_ev"+Str((int)(100*OptS->evaporate))+"_cl"+Str(OptS->clusters)+"_gbest"+Str((int)(100*OptS->gbest))+"_pbest"+Str((int)(100*OptS->pbest))+"_steps"+Str(OptS->steps)+"_runs"+Str(runs)+"_swapselect"+Str((float)(HelixPso::swap_select))+"_"+Str((int)RNA.size())+".txt";


  //remove(filename.c_str());
  //ofstream outfile(filename.c_str(),std::ios_base::out | std::ios_base::trunc);//app);
 
  // ofstream outfile(filename.c_str());//ios_base::in  app
  // std::string filename="testHelixPso/"+algo+_p"+Str(OptS->particles)+"_it"+Str(OptS->iterations)+"_ev"+Str((int)(100*OptS->evaporate))+"_cl"+Str(OptS->clusters)+"_gbest"+Str((int)(100*OptS->gbest))+"_pbest"+Str((int)(100*OptS->pbest))+"_steps"+Str(OptS->steps)+"_runs"+Str(runs)+"_swapselect"+Str((float)(HelixPso::swap_select))+"_"+Str((int)RNA.size())+".txt";


  std::vector<double> solutions_report=std::vector<double>();
 
  //measure time before running algorithm
  std::pair<double,std::vector<int> > best_solution;


  //  std::pair<int,int> best_pred_in_all_runs= std::pair<int,int>();
  std::vector<std::pair<int,int> > pred_of_global_bests=std::vector<std::pair<int,int> >();
  std::pair<int,int> best_pred_of_last_generation=std::pair<int,int> ();

  for(int i=0;i<runs;i++) { 
    
    if(OptS->centroid<0) {
      HelixPso::centroid_weight=(double)(i+1)/(double)(runs);
      //cout<<"run "+Str(i)+" lambda:"+Str(HelixPso::centroid_weight)<<std::endl;
    }

    //  std::pair<double,std::string> struc=p.Evaluate(RNA,native_structure);

    //  double e_native=energy_of_struct(const_cast<char*>(RNA.c_str()),const_cast<char*>(native_structure.c_str()));
    //std::pair<double,std::string> struc= std::pair<double,std::string>(e_native,native_structure);
    //double score=Score(struc,OptS->centroid,mfe);

    // double centroid_component=HelixPso::CentroidMatchBpCount(native_structure).first/(double)HelixPso::bp_centroid.size();
    //    cout<<"nativ "+native_structure+" "+Str(centroid_component)<<std::endl;

      std::vector<std::string> structures;
   std::string s1="......((.......))..((((....)))).......(((((..((((...........(((((.......))))).((((((((...))))))))..)))).((......)).)))))";
        std::string s2=".(((((((((........(((((................))))).((((...................(((...))).((((((((...))))))))..))))......)))))))))..";
	//	structures.push_back(s1);
	//	structures.push_back(s2);


// 	structures.push_back("........((((...((((((....))............(((((...............(((....)))....)))))))))..)))).....((((....((((....))))...))))");
// 	structures.push_back("........((((...((((((....))............(((((...............(((....)))....)))))))))..)))).....((((....((((....))))...))))");
// 	structures.push_back("((((((((((......((((..(((...))).((((((((((.................(((....))).........))))))))))......))))...........)))))))))).");
// 	structures.push_back("........((((...((((((....))............(((((...............(((....)))....)))))))))..)))).....((((....((((....))))...))))");
// 	structures.push_back("........((((...((((((....))............(((((...............(((....)))....)))))))))..)))).....((((....((((....))))...))))");
// 	structures.push_back("((((((((((......((((..(((...))).((((((((((.................(((....))).........))))))))))......))))...........)))))))))).");

// structures.push_back("........((((...((((((....))............(((((...............(((....)))....)))))))))..))))......(((....((((....))))...))).");
// structures.push_back("........((((...((((((....))............(((((...............(((....)))....)))))))))..)))).....((((....((((....))))...))))");
// structures.push_back("((((((((((......((((..(((...))).((((((((((.................(((....))).........))))))))))......))))...........)))))))))).");
// structures.push_back("........((((...((((((....))............(((((...............(((....)))....)))))))))..)))).....((((....((((....))))...))))");
// structures.push_back("........((((...((((((....))............(((((...............(((....)))....)))))))))..)))).....((((....((((....))))...))))");
// structures.push_back("((((((((((......((((..(((...))).((((((((((.................(((....))).........))))))))))......))))...........)))))))))).");
// structures.push_back("((((((((((.........((((((...)))..)))......................((((......(((...))).))))......((((..(((....))))))).)))))))))).");
// structures.push_back("((((((((((.........((....)).......(((........((((..........(((......(((...)))......(((....)))..))).)))).)))..)))))))))).");
// structures.push_back("((((((((((.....((((.((((............))))....................(((((.......))))).))))......((((..(((....))))))).)))))))))).");
// structures.push_back(".(((((((((.........((....)).......(((..(((((...............(((....)))....)))))....))).....(((.(((....))))))..)))))))))..");
// structures.push_back(".(((((((((......((((..((((((((((((.............)))).........(((((.......)))))...))))))))......))))...........)))))))))..");
// structures.push_back("((((((((((.........((((....))))...(((..(((((...............(((....)))....)))))....))).((((....(((....))))))).)))))))))).");
// structures.push_back(".(((((((((...............(((..((((.............)))).........(((((.......)))))......)))..((((..(((....))))))).)))))))))..");
// structures.push_back(".(((((((((.........((.....))....((((((((((..................(((((.......))))).))))))))))((((..(((....))))))).)))))))))..");
// structures.push_back("((((((((((............((((((((......((((...................(((....)))...))))....))))))))..(((.(((....))))))..)))))))))).");
// structures.push_back("((((((((((.......((((((.......((((.............))))........))))))...(((...))).((((((((...))))))))............)))))))))).");
// structures.push_back(".(((.....((....)).....))).............(((((..((((...........(((((.......))))).((((((((...))))))))..)))).((......)).)))))");
// structures.push_back("......((.......))..((((....)))).......(((((..((((...........(((((.......))))).((((((((...))))))))..)))).((......)).)))))");
// structures.push_back(".(((((((((........(((((................))))).((((...................(((...))).((((((((...))))))))..))))......)))))))))..");
	  

      std::string best_structure;
      if(algo=="HELIXPSO"){
        HelixPso h=HelixPso(&p,&sp,OptS->clusters);
        h.GetChromosomes();
        h.GetInitialPopulation();
        h.InitializeControlVariables();  
	//THIS MAY NEED TO BE TAKEN OUT
        h.iterations= (int)(.5+(double)OptS->total_solutions/(double)OptS->particles);
        //cout<<h.iterations<<std::endl;
        for(int j=0;j<h.iterations;j++) {
	  //	 	       if(j%10==0) cout<<"Run:"+Str(i)+", Iteration:"+Str(j)+":\n";
	  h.DoIteration();
          string best_solution=p.Evaluate(RNA,HelixPso::ChromosomeToNode(h.gbest.back().second,HelixPso::stemlist)).second;
	  if(h.HaveEnoughSolutions()) break;
        }
        solutions_report=h.solutions_report;
	best_solution=h.best_solution;
	structures=h.GetStructures();


	std::vector<std::string> frequent_structures=h.ReturnMostFrequentStructures();
	if(verbose) cout<<"frequent_structures"<<std::endl;
       int frequency =h.StructureHasFrequency(frequent_structures[0]);
       //cout<<"frequency "<<frequency<<std::endl;
       if(verbose){
         for(int k=0;k<(int)frequent_structures.size();k++){
           cout<<frequent_structures[k]<<std::endl;
         }
       }

   std::vector<std::string> choice_structures=std::vector<std::string> ();

   if(frequency==1){
	int n_struc=(int)structures.size();
         float ** D=(float **)space((n_struc+1)*sizeof(float *));
	 for(int j=0; j<=n_struc; j++)
	   D[j] = (float *)space((n_struc+1)*sizeof(float));
	 D[0][0] = (float)n_struc;
	 D[1][1] = 0.0;
	 for(int j=2; j<=n_struc; j++) {
	   D[j][j] = 0.0;
	   for(int k=1; k<j; k++) {
             int distance= bp_distance(const_cast<char*>(structures[j-1].c_str()),const_cast<char*>(structures[k-1].c_str()));
 	     //HelixPso::Distance(structures[j-1],structures[k-1]);
	     D[j][k] = distance;
	     D[k][j] = distance;
	   }
	 }
        Split  * S = split_decomposition(D);
        sort_Split(S);

        //print the size and content of every split group, select the biggest one

  std::vector<std::string> clustered_structures=std::vector<std::string> ();
  if(verbose) cout<<"> "+Str(S[0].splitsize)+" Split Decomposition"<<std::endl;
  int max_split_size=0;
  vector<int> max_split_idxs= vector<int>();
   for (int k=1; k<=S[0].splitsize; k++) {
     //cout<<"k "<<k<<std::endl;
      if( (S[k].splitlist[0])&&(S[k].splitlist[1]) ) {
	//printf("\n%3d   %8.4f  : {",k,S[k].isolation_index);
	int size=S[k].splitsize;
	/*
         cout<<" size of split "+Str(size)<<std::endl;
	 cout<<"length of list "+Str(S[k].splitsize)+" ";
         for(int j=1;j<=S[k].splitsize;j++) {
           cout<<" "+Str(S[k].splitlist[0][j])+" \n";
	 }
	*/
         if(size==max_split_size) {
	   //for(int j=1;j<=S[k].splitsize;j++) clustered_structures.push_back(Str(k)+" "+Str(j)+" "+structures[S[k].splitlist[0][j]-1]);
           for(int j=1;j<=S[k].splitsize;j++) clustered_structures.push_back(structures[S[k].splitlist[0][j]-1]);
	 }
         else if(size>max_split_size){
	   max_split_size=size;
           clustered_structures.clear();
	   //           for(int j=1;j<=S[k].splitsize;j++) clustered_structures.push_back(Str(k)+" "+Str(j)+" "+structures[S[k].splitlist[0][j]-1]);
           for(int j=1;j<=S[k].splitsize;j++) clustered_structures.push_back(structures[S[k].splitlist[0][j]-1]);
	 }
      }
   }   
   if(verbose){
     for(int l=0;l<(int)clustered_structures.size();l++){
       cout<<clustered_structures[l]<<std::endl;
     }
   }
   choice_structures=clustered_structures;
   }
   else choice_structures=frequent_structures;
   //select a random structure:
   int choice=HelixPso::RandInt((int)choice_structures.size());

   if(verbose) cout<<"Choose structure "+Str(choice)+" out of "+Str((int)choice_structures.size())<<std::endl;

   best_structure=choice_structures[choice];//.substr(4);
   //   cout<<"Best structure "+Str(best_structure)<<std::endl;



   // }//ENDIF(frequency==1){


   //    cout<<"Print"<<std::endl;
//       //Print out maximal indices
//       for(int k=0;k<(int)max_split_idxs.size();k++){
// 	int idx=max_split_idxs[k];
//         cout<<"idx "+Str(idx)<<std::endl;
// 	cout<<"length of list "+Str(S[idx].splitsize)+" ";
// 	for(int j=1;j<=S[idx].splitsize;j++) {
//           cout<<"j "+Str(j)<<std::endl;
//           cout<<" "+Str(S[idx].splitlist[0][j])+" ";
// 	}

//       }

        //  for(int j=1;j<=S[k].splitsize;j++) cout<<" "+Str(S[k].splitlist[0][j])+" ";
//          cout<<"   |";
//          int bound=(S[k].splitlist[0][0]-S[k].splitsize);
// 	 for(int j=1;j<=bound;j++)  cout<<" "+Str(S[k].splitlist[1][j])+" ";
//          cout<<" } ";
   
   
   // cout<<"\n      "+Str(S[0].isolation_index)+"  : { [Split prime fraction] }\n";




	//        best_structure=h.Evaluate(best_solution.second).second;
 //	best_structure=h.SelectLowestDistanceStructure();
      //   int frequency =h.StructureHasFrequency(best_structure);
      //  cout<<"frequency "<<frequency<<std::endl;


 



      //    best_structure=h.ReturnMostFrequentStructure();//h.Evaluate(h.chromosomes[0].second).second;
      //	std::vector<std::string> structures=h.GetStructures();

      //select the best structures;


   // best_structure=clustered_structures[0].substr(4);
   //  cout<<"selected as best structure\n"<<best_structure<<std::endl;
        for(int k=0;k<(int)structures.size();k++){
	  //	  cout<<structures[k]<<std::endl;
	}
        

      }
double energy=energy_of_struct(const_cast<char*>(RNA.c_str()),const_cast<char*>(best_structure.c_str()));
      std::string prediction="Output   "+best_structure+" "+Str(energy);//+" "+Str(best_solution.first);
      sLog+=prediction+"\n";
      cout<<prediction<<std::endl;
      
      std::pair<int,int> pred_best=HelixPso::CorrectlyPredictedBpCount(best_structure);
      //XXXX      
      if(do_stats) cout<<"Predicts "+Str(pred_best.first)+" out of "+Str(pred_best.second)+" basepairs correctly \n"<<std::endl;
      pred_of_global_bests.push_back(pred_best);

      TP.push_back((double)pred_best.first);
      if(pred_best.first>best_pred_of_global_bests.first) best_pred_of_global_bests=pred_best;
      
        best_by_run.push_back(solutions_report.back());

        // std::string sMean="";
//         sMean+="set of mean best energies for "+Str(i+1)+" runs:\n";
//         cout<<"Get solution intervals "<<std::endl;
//         for(int j=0;j<n_solutions_to_print;j++) {
// 	  cout<<j<<"out of"<<n_solutions_to_print<<std::endl;
//           //mean_best[j]/=runs;
//           mean_best[j]+=solutions_report[j];
//           sMean+=Str(j)+" "+Str(mean_best[j]/(i+1))+"\n";
//         }
//	cout<<"write to file _"<<filename.c_str()<<"_"<<std::endl;
        //remove(filename.c_str());
	//sleep(5);
	//cout<<"removed old "<<std::endl;
	//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX HIER       
 //	cout<<sLog<<std::endl;
        //outfile << sLog;
	//cout<<"written log "<<std::endl;
	//        outfile << sMean;
	//cout<<"written sMean "<<std::endl;
        //outfile.close();
	//cout<<"written to file "<<std::endl;
        sLog="";
		if(do_stats){
		  //	  cout<<"Do stats"<<std::endl;
  //av of solutions in bp/%,best globalbest,best solution ever,best solution in any last generation 
  double best_global_best_TP=(double)best_pred_of_global_bests.first;
  double best_global_best_sens=best_global_best_TP/(double)HelixPso::bp_native.size();
  double best_global_best_spec=best_global_best_TP/(double)best_pred_of_global_bests.second;
  double best_global_best_F_mu=2.0*best_global_best_sens*best_global_best_spec/(best_global_best_sens+best_global_best_spec);
  std::string best_global_best="best_global_best:"+Str(best_global_best_TP)+","+Str(best_pred_of_global_bests.second)+","+Str(best_global_best_sens)+","+Str(best_global_best_spec)+","+Str(best_global_best_F_mu)+"\n";

//   double best_ever_TP=HelixPso::best_pred_in_all_runs.first;
//   double best_ever_sens=best_ever_TP/(double)HelixPso::bp_native.size();
//   double best_ever_spec=best_ever_TP/(double)HelixPso::best_pred_in_all_runs.second;
//   double best_ever_F_mu=2.0*best_ever_sens*best_ever_spec/(best_ever_sens+best_ever_spec);
//   std::string best_ever="best_ever:"+Str(best_ever_TP)+","+Str(HelixPso::best_pred_in_all_runs.second)+","+Str(best_ever_sens)+","+Str(best_ever_spec)+","+Str(best_ever_F_mu)+"\n";

//   //static h.best_last_gen
//   double best_lastgen_TP=(double)HelixPso::best_lastgen.first;
//   double best_lastgen_sens=best_lastgen_TP/(double)HelixPso::bp_native.size();
//   double best_lastgen_spec=best_lastgen_TP/(double)HelixPso::best_lastgen.second;
//   double best_lastgen_F_mu=2.0*best_lastgen_sens*best_lastgen_spec/(best_lastgen_sens+best_lastgen_spec);
//   std::string best_lastgen="best_lastgen:"+Str(best_lastgen_TP)+","+Str(HelixPso::best_lastgen.second)+","+Str(best_lastgen_sens)+","+Str(best_lastgen_spec)+","+Str(best_lastgen_F_mu)+"\n";


  double global_best_TP_mean=GetMean(TP);
  double global_best_sens_mean=global_best_TP_mean/(double)HelixPso::bp_native.size();
  std::string global_best_mean="global_best_mean:"+Str(global_best_TP_mean)+","+Str(global_best_sens_mean)+"\n";


 string TPlog="Run "+Str(i)+":\n"+best_global_best+global_best_mean;

 //  string TPlog="Run "+Str(i)+":\n"+best_global_best+best_ever+best_lastgen+global_best_mean;
  //XXXX cout<<TPlog;
  sLog+=TPlog;
		}
  }

  //  sLog+="set of mean best energies for "+Str(runs)+" runs:\n";
  //  for(int j=0;j<n_solutions_to_print;j++) {
    //mean_best[j]/=runs;
    //mean_best[j]+=solutions_report[j];
  //    sLog+=Str(j)+" "+Str(mean_best[j]/runs)+"\n";
  //  } 
  //best solution
  finish = clock();
  runningtime = (double(finish)-double(start))/CLOCKS_PER_SEC;
  std::string sRuntime="Run time:"+Str(runningtime)+" seconds";

  //  cout<<sRuntime<<endl;
  //calculate the variance:
  double variance=GetVariance(best_by_run);
  if(do_stats) sLog+="variance:"+Str(variance)+"\n";
  sLog+=sRuntime+"\n";
  //remove(filename.c_str());
  //ofstream outfile(filename.c_str(),std::ios_base::out | std::ios_base::app);
  // ofstream outfile(filename.c_str(),ios_base::trunc);
  cout<<sLog<<std::endl;
  //outfile << sLog;
  //   outfile.close();
  //cout<<"Outfile "+filename+"\n"; 

  //STATISTICS
#ifdef DO_STATS
  if(HelixPso::transposition_count_sections>0){
    int index_sum_1st=0;
    int index_sum_2nd=0;
    std::string sTcount="Transposition counts for "+Str(runs)+" runs and "+Str(HelixPso::transposition_count_sections)+" sections.\n";
    //HelixPso::transposition_count_sections
    for(int i=0;i<HelixPso::transposition1st_counter.size();i++){
      sTcount+="section "+Str(i)+"for 1st idx:\n";
      for(int j=0;j<HelixPso::transposition1st_counter[i].size();j++){
        sTcount+=Str(j)+" "+Str(HelixPso::transposition1st_counter[i][j]/runs)+"\n";
        index_sum_1st+=HelixPso::transposition1st_counter[i][j];
      }
    }
    sTcount+="index_sum_1st:"+Str(index_sum_1st)+"\n"; 
    for(int i=0;i<HelixPso::transposition2nd_counter.size();i++){
      sTcount+="section "+Str(i)+" for 2nd idx:\n";
      for(int j=0;j<HelixPso::transposition2nd_counter[i].size();j++){
        sTcount+=Str(j)+" "+Str(HelixPso::transposition2nd_counter[i][j]/runs)+"\n";
        index_sum_2nd+=HelixPso::transposition2nd_counter[i][j];
      }
    }
    sTcount+="index_sum_2nd:"+Str(index_sum_2nd)+"\n"; 
    std::string tcounts_filename=filename+".tcounts";
    ofstream outfile(tcounts_filename.c_str());
  outfile << sTcount;
  outfile.close();
  }
  if(HelixPso::accepted_solution_count_sections>0){
    double sum=0;
    std::string sAScount="Accepted solution counts for "+Str(runs)+" runs and "+Str(HelixPso::accepted_solution_count_sections)+" sections.\n";
    //HelixPso::accepted_solution_count_sections
    for(int i=0;i<HelixPso::accepted_solution_counter.size();i++){
      double solutions_per_run_in_section=HelixPso::accepted_solution_counter[i]/(double)(runs);
      sAScount+=Str(i)+" "+Str(solutions_per_run_in_section)+"\n";
      sum+=solutions_per_run_in_section;
    }
    sAScount+="sum:"+Str(sum)+"\n"; 
  
    std::string ascounts_filename=filename+".ascounts";
    ofstream outfile(ascounts_filename.c_str());
  outfile << sAScount;
  outfile.close();
  }

  if(HelixPso::sv_stat_sections>0){
    double iterations=OptS->total_solutions/(double)OptS->particles;
    double iterations_per_section=iterations*(1-OptS->gafrac)/((double)HelixPso::sv_stat_sections);
    //    cout<<" iterations:"+Str(iterations)+":\n";
    //cout<<" iterations_per_section:"+Str(iterations_per_section)+":\n";
    //how many iterations worth of solution are generated by the GA?
    // double ga_iterations=0;//OptS->gafrac*iterations;
    std::string sSvstat="SV statistics for "+Str(runs)+" runs and "+Str(HelixPso::sv_stat_sections)+" sections.\n";
    //HelixPso::transposition_count_sections

    //scales down total numbers to values for an average SV vector.
    double CallsToUpdateSVPerSection=(double)(runs*HelixPso::iterations_done*OptS->particles)/(double)HelixPso::sv_stat_sections;
    for(int i=0;i<HelixPso::sv_stat_sections;i++){
      //only count the number of iterations that are left for a section after all ga_iterations have been used up    
      sSvstat+="section "+Str(i)+":\n";    
      //if(ga_iterations<iterations_per_section) {
	//double actual_iterations_in_section=iterations_per_section-ga_iterations;
        //cout<<"actual_iterations_in_section:"+Str(actual_iterations_in_section)+":\n";
        //ga_iterations=0.0;
        
        for(int j=0;j<HelixPso::sv_distribution_counter[i].size();j++){
	  sSvstat+=Str(HelixPso::sv_mass_fractions[j])+" "+Str(HelixPso::sv_distribution_counter[i][j]/CallsToUpdateSVPerSection)+"\n";
	//sSvstat+=Str(HelixPso::sv_mass_fractions[j])+":"+Str(HelixPso::sv_distribution_counter[i][j])+"\n";
	}
        sSvstat+=Str((double)HelixPso::sv_length_counter[i]/CallsToUpdateSVPerSection)+" "+Str(HelixPso::sv_mass_counter[i]/CallsToUpdateSVPerSection)+"\n";
	//}
	//else {
	//sSvstat+" GA\n";
        //ga_iterations-=iterations_per_section;
	//}
    }
    std::string svstat_filename=filename+".svstat";
    ofstream outfile(svstat_filename.c_str());
  outfile << sSvstat;
  outfile.close();
  }

 
#endif //#ifdef DO_STATS
  return 0;
}

// End of file
